
fgcolors = new Array("inherit", "#000080", "#800000", "#008000", "#800080", "#008080");
bgcolors = new Array("inherit", "#F5F5F5", "#EBEBEB", "#E1E1E1", "#D7D7D7", "#CDCDCD");
var pcolortext, pcolorbg, pbordercolor, pbordermode, pborderwidth;
const MAX_LEVELS = 5;

function getColorsAndPrefs()
{

  var prefstringfg = "quotecolors.fg.l";
  var prefstringbg = "quotecolors.bg.l";
      
  for( var i=1;i<=MAX_LEVELS;i++)
  {
    fgcolors[i] = nsPreferences.copyUnicharPref(prefstringfg + i, fgcolors[i]);
    bgcolors[i] = nsPreferences.copyUnicharPref(prefstringbg + i, bgcolors[i]);
  }

  pcolortext = nsPreferences.getBoolPref("quotecolors.colorText", true);
  pcolorbg = nsPreferences.getBoolPref("quotecolors.colorBackground", true);

  pbordermode = nsPreferences.getIntPref("quotecolors.borderMode", 0);
  pbordercolor = nsPreferences.copyUnicharPref("quotecolors.bordercolor", "#000000");
  var borderwidth = nsPreferences.getIntPref("quotecolors.borderwidth", 1);
  switch (borderwidth)
  { 
    case 0:
      pborderwidth="thin";
      break;
    case 1:
      pborderwidth="medium";
      break;
    case 2:
      pborderwidth="thick";
      break;
   }
}


function colorblockquotes(element,level)
{
if(!element) return;
var children = element.childNodes;
var num = children.length;
if(!num) return;

level++;
if(level>MAX_LEVELS) level=MAX_LEVELS;

  for (var i=0; i < num; i++)
  {

    if(children[i].nodeName.toLowerCase()=="blockquote" && children[i].getAttribute("type")=="cite")
    {
      if(pcolortext)
        children[i].style.color = fgcolors[level];
      else
        children[i].style.color = "inherit";
      if(pcolorbg)
        children[i].style.backgroundColor = bgcolors[level];

      if(pbordermode==0)
        children[i].style.borderColor = fgcolors[level];
      else
        children[i].style.borderColor = pbordercolor;

      children[i].style.borderWidth = pborderwidth;
      colorblockquotes(children[i],level);
    }
  }

}


function setViewQuotecolor() {

  var content = document.getElementById("messagepane");
  if(!content) return;
  var mailmsg = content.contentDocument;
  getColorsAndPrefs();
  colorblockquotes(mailmsg.getElementsByTagName("div").item(0),0);

}
